// Bk.cpp : Defines the class behaviors for the application.
#include "stdafx.h"
#include "Bk.h"
#include "MainFrm.h"
#include "BkDoc.h"
#include "BkView.h"
#include "DU600.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CBkApp
BEGIN_MESSAGE_MAP(CBkApp, CWinApp)
	//{{AFX_MSG_MAP(CBkApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()
//________________________________________
// CBkApp construction
CBkApp::CBkApp()
{
	//Botes de dialogue non modales________
	m_pRegDlg=NULL;
	//Port srie
	m_radioPort=0;
	m_OKConnect=FALSE;
	//Spectrophotomtre_____________________
	m_pDU600=NULL;

	//Plumes lambda: 600 plumes, 1 plume par nm entre 400 et 1000 nm 
	//p[0] -> 400 nm, p[599] -> 1000 nm
	pl=new CPen[600];
	unsigned char R,G,B;
	short i;
	for (i=0;i<600;i++) 
	{
		CoulLambda(i+400,&R,&G,&B);//i+400 = longueur d'onde
		pl[i].CreatePen(PS_SOLID,70,RGB(R,G,B));
	}

}
CBkApp::~CBkApp()
{
	for (short i=0;i<600;i++) pl[i].DeleteObject();
	delete []pl;
}
//________________________________________
// The one and only CBkApp object

CBkApp theApp;
//________________________________________
// CBkApp initialization
BOOL CBkApp::InitInstance()
{
	// Standard initialization

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	if (!AfxOleInit())
	{
		AfxMessageBox("Erreur d'initialisation de COM dll !");
		return FALSE;
	}


	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register document templates

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CBkDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CBkView));
	AddDocTemplate(pDocTemplate);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	return TRUE;
}
//________________________________________
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CListBox	m_liste;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_LISTE, m_liste);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
//Couleurs d'aprs longueur d'onde
void CBkApp::CoulLambda(int lambda,unsigned char* rouge,unsigned char* vert,unsigned char* bleu)
{
	if (lambda>=630+127)
  {
		//IR lointain
		*rouge=127;
		*vert=127;
		*bleu=127;
  }
  else
	if (lambda>630 && lambda<630+127)
	{
		//IR
		*rouge=255-(lambda-630);
		*vert=lambda-630;
		*bleu=lambda-630;
	}	           
	else 
	{
		//Visible, UV
		float
			a,b;
			a=(float)(1023.0/(430-630)); //Rfrence: 640:Rouge, 430:Bleu
			b=-a*640;	
		
		lambda=(int)(a*lambda+b);
		if (lambda<0) lambda=0;
		int banque=lambda/256;//5 banques de 256 chantillons
		switch(banque)
		{
			case 0://0<=lambda<=255, R=255, V=0  255, B=0
				*rouge=255;
				*vert=lambda;
				*bleu=0;
			break;
			case 1://256<=lambda<=511, R=255  0, V=255, B=0
				*rouge=511-lambda;
				*vert=255;
				*bleu=0;
			break;
			case 2://512<=lambda<=767, R=0, V=255, B=0  255
				*rouge=0;
				*vert=255;
				*bleu=lambda-512;
			break;
			case 3://768<=lambda<=1023, R=0, V=255  0, B=255
				*rouge=0;
				*vert=1023-lambda;
				*bleu=255;
			break;
			case 4://1024<=lambda<=1279, R=0  255, V=0, B=255
				*rouge=lambda-1024;
				*vert=0;
				*bleu=255;
			break;
		}
	}
}
// App command to run the dialog
void CBkApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}
//________________________________________
// CBkApp commands
BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_liste.AddString("23/07/07: Nouvel icne");
	m_liste.AddString("15/09/06: Augmentation taille caractres marque de pointage");
	m_liste.AddString("05/11/05: Bote de dialogue para. standards FW");
	m_liste.AddString("31/10/05: Oprations en mode Fixed Wavelength");
	m_liste.AddString("28/10/05: Ajout lgendes");
	m_liste.AddString("25/10/05: Dcalage affichage barres");
	m_liste.AddString("18/10/05: Wavelength Reading");
	m_liste.AddString("12/10/05: Optimisation gestion des sries");
	m_liste.AddString("06/10/05: Ecriture programme sur base SDI");
	return TRUE;
}
