// BkDoc.cpp : implementation of the CBkDoc class
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "Regres.h"
#include "Accro.h"
#include "Bkview.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CBkDoc
IMPLEMENT_DYNCREATE(CBkDoc, CDocument)

BEGIN_MESSAGE_MAP(CBkDoc, CDocument)
	//{{AFX_MSG_MAP(CBkDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
CBkDoc::CBkDoc()
{
	m_pApp=((CBkApp*)AfxGetApp());
	//Coordonnes souris____________________
	m_iDx=0;
	m_iDy=0;
	m_fDx=0;
	m_fDy=0;
	m_iX=-1;
	m_iY=-1;
	//Dimensions initiales fentre en mm____
	m_fLarg=270;
	m_fHaut=195;
	//Fentre graphique
	m_fXmi=-m_fLarg/2;
	m_fYmi=-m_fHaut/2;
	m_fXma=m_fLarg/2;
	m_fYma=m_fHaut/2;
	//Dcalage d'origine, chelles et facteurs d'chelle
	m_fXori=0;
	m_fYori=0;
	m_fEchx=1;
	m_fEchy=1;
	m_fFactx=1;
	m_fFacty=1;  
	//Tableau_______________________________
  m_iNbMax=800;	//Nb. de lignes du tableau: de 200  1000 nm avec un pas de 1 nm
	m_iNbCol=7;	//Nb. de colonnes du tableau		

  m_iNb=m_iNbMax;//=0;
 
	m_fT=new float[m_iNbMax][7];//7: m_iNbCol
	Init_m_fT();
	//Rgressions polynomiales______________
	m_pReg=new CRegres();
	//Classe accrochage au graphique
	m_pAc=new CAccro(this,m_iNbCol);
	//Acquisitions__________________________
	m_tOrd[0].RemoveAll();
	m_tOrd[0].Add("?");m_tOrd[0].Add("ABS");m_tOrd[0].Add("T%");m_tOrd[0].Add("_________");
	m_tAbs[0].RemoveAll();
	m_tAbs[0].Add("Lambda(nm)");m_tAbs[0].Add("__________");

	m_tOrd[1].RemoveAll();
	m_tOrd[1].Add("(0)  (5)");m_tOrd[1].Add("?");m_tOrd[1].Add("ABS");m_tOrd[1].Add("T%");m_tOrd[1].Add("ABS/Calcul");m_tOrd[1].Add("T%/Calcul");m_tOrd[1].Add("___________");
	m_tAbs[1].RemoveAll();
	m_tAbs[1].Add("N srie");m_tAbs[1].Add("N cuvette");m_tAbs[1].Add("N chantillon");m_tAbs[1].Add("___________");

	short i;
	for (i=0;i<10;i++) 
	{
		m_iLambda[i]=1000;			//Longueur d'onde par dfaut pour chaque barre (dfinit la couleur)
		m_sIntBarre[i]="";			//Intitul de la barre, aprs (A) .....
		m_OKB[i]=TRUE;					//Trac de la barre dans la srie, OUI ou NON
		m_fPlus[i]=0;
		m_fMult[i]=143.0;
	}
	m_iNoAbs[0]=0;			//Absisse par dfaut pour WS
	m_iNoOrd[0]=0;			//Ordonne par dfaut pour WS
	m_iNoAbs[1]=0;			//Ordonne par dfaut pour WR
	m_iNoOrd[1]=0;			//Absisse par dfaut pour WR

	m_iNoSerie=0;				//Jusqu'a m_iNbCol-1 sries
	m_iTypeGr=0;				//N'est pas utilis ici. Toujours nul : cartsien ou polaire...
	m_iNbCar=0;
	//m_iVisuGr=1+2+4+8+16+32; //Toutes les sries
	m_iVisuGr=0;				//Aucune srie
	m_iTypeAcq=0;				//0: WaveLengthScan, 1: WaveLengthReading
	//Lit le fichier bk.$$$ sur disque s'il existe et en trace le graphe...
	//Analyse_buffer(&m_iNoSerie);
}
//________________________________________
CBkDoc::~CBkDoc()
{
	delete[] m_fT;
	delete m_pReg;
	delete m_pAc;}
//________________________________________
BOOL CBkDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}
//////////////////////////////////////////
// CBkDoc serialization
void CBkDoc::Serialize(CArchive& ar)
{
	short i,j;
	CString s="";
	if (ar.IsStoring())
	{
		//Types reconnus:
		//CObject*,SIZE and CSize,float,WORD,CString,POINT and CPoint,DWORD,BYTE,RECT and CRect,double,
		//LONG,CTime and CTimeSpan
		
		//Oprations de sauvegarde
		ar<<s;
		ar<<s;

		ar<<(short)m_iTypeAcq;           
		ar<<(short)m_iNoAbs[0];           
		ar<<(short)m_iNoAbs[1];           
		ar<<(short)m_iNoOrd[0];           
		ar<<(short)m_iNoOrd[1];           
		ar<<(int)m_iVisuGr;           
		ar<<(short)m_iNb;           
		ar<<(short)m_iNbMax;

		ar<<(short)m_iNbCol;           

		for (i=0;i<10;i++)
		{
			ar<<(short)m_iLambda[i];
			ar<<m_sIntBarre[i];
			ar<<(short)m_OKB[i];
			ar<<m_fPlus[i];
			ar<<m_fMult[i];
		}

		for (i=0;i<m_iNb;i++)
		{
			for (j=0;j<m_iNbCol;j++)
			{
				ar<<m_fT[i][j];
			}
		} 
		//Paramtres rgressions
		for (i=0;i<3;i++)
		{
			for (j=0;j<9;j++)
			{
				ar << m_pReg->m_fa[i][j];
			}
			for (j=0;j<2;j++)
			{
				ar << m_pReg->m_fP1[i][j];			
				ar << m_pReg->m_fP2[i][j];
				ar << (short)m_pReg->m_iNoColX[i][j];
				ar << (short)m_pReg->m_iNoColY[i][j];
		 		ar << (short)m_pReg->m_iNoPt[i][j];
				ar << (short)m_pReg->m_OKPt[i][j];
			}
	 		ar << (short)m_pReg->m_iNoBtn[i];
			ar << (short)m_pReg->m_iType[i];
	 		ar << (short)m_pReg->m_OKCalcul[i];
	 		ar << (short)m_pReg->m_OKTrace[i];
		}
	}
	else
	{
		//Oprations de lecture
		ar>>s;
		ar>>s;

		ar>>(short&)m_iTypeAcq;           
		ar>>(short&)m_iNoAbs[0];           
		ar>>(short&)m_iNoAbs[1];           
		ar>>(short&)m_iNoOrd[0];           
		ar>>(short&)m_iNoOrd[1];           
		ar>>(int&)m_iVisuGr;           
		ar>>(short&)m_iNb;
		ar>>(short&)m_iNbMax;
		ar>>(short&)m_iNbCol;

		for (i=0;i<10;i++)
		{
			ar>>(short&)m_iLambda[i];
			ar>>m_sIntBarre[i];
			ar>>(short&)m_OKB[i];
			ar>>m_fPlus[i];
			ar>>m_fMult[i];
		}

		for (i=0;i<m_iNb;i++)
		{
			for (j=0;j<m_iNbCol;j++)
			{
				ar>>m_fT[i][j];
			}
		}
		//Paramtres rgressions
		for (i=0;i<3;i++)
		{
			for (j=0;j<9;j++)
			{
				ar >> m_pReg->m_fa[i][j];
			}
			for (j=0;j<2;j++)
			{
				ar >> m_pReg->m_fP1[i][j];			
				ar >> m_pReg->m_fP2[i][j];
				ar >> (short&)m_pReg->m_iNoColX[i][j];
				ar >> (short&)m_pReg->m_iNoColY[i][j];
		 		ar >> (short&)m_pReg->m_iNoPt[i][j];
				ar >> (short&)m_pReg->m_OKPt[i][j];
			}
	 		ar >> (short&)m_pReg->m_iNoBtn[i];
			ar >> (short&)m_pReg->m_iType[i];
	 		ar >> (short&)m_pReg->m_OKCalcul[i];
	 		ar >> (short&)m_pReg->m_OKTrace[i];
		}
	}
}
//////////////////////////////////////////
// CBkDoc diagnostics
#ifdef _DEBUG
void CBkDoc::AssertValid() const
{
	CDocument::AssertValid();
}
void CBkDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG
//////////////////////////////////////////
// CBkDoc commands
void CBkDoc::Init_m_fT(void)
{
	short i,j;
	for (i=0;i<m_iNbMax;i++)
	{
		for (j=0;j<m_iNbCol;j++)
		{
			m_fT[i][j]=1e10;
		}
	}
	m_iNb=m_iNbMax;
}
//________________________________________
void CBkDoc::Analyse_buffer(short *p_serie)
{
	//Analyse du contenu du fichier bk.$$$
	short 
		serie,
		i,j,k,no,col;
	int n;
	float 
		v[12],
		r,r1;
	CString s;
	char c,c1[1];

	i=0;k=0;
	s.Format("%150s"," ");

	serie=*p_serie;
	//On regarde si le fichier bk.$$$ existe, si oui on l'analyse
	BOOL 
		NouvSerie=FALSE,
		ok;
	CFileException p_Error;
	ok=m_Fic.Open("bk.$$$",CFile::modeRead,&p_Error);
	if (ok)
	{
		//Taille du fichier
		m_iNbCar=m_Fic.GetLength();
		m_iNb=0;
		col=0;
		for (i=0;i<m_Fic.GetLength();i++)
		{
			m_Fic.Read(c1,1);c=c1[0];
			if (c=='\n')
			{
				//La ligne est isole
				s.SetAt(k,'\0');
				//AfxMessageBox(s);
				//Recherche nom axe ordonne
				if (s.Find("ABS")>=0)	
				{
					//?
				}
				if (s.Find("TRA")>=0)
				{
					//?
				}
				//On regarde si la ligne commence par un n d'chantillon [1, 80]
				no=-1;n=sscanf(s,"%d",&no);
				//Un fichier WavelengthScan commence toujours par une long. d'onde > 80 nm
				if (n==1 && no>=1 && no<=80)
				{
					//Ce n d'chantillon est valide
					//CString z;z.Format("WR, %s",s);AfxMessageBox(z);
					m_iTypeAcq=1;//WaveLengthReading
					//Initialisation des absisses et ordonnes WR
					m_iNoAbs[1]=0;	//?
					m_iNoOrd[1]=0;	//N srie
					for (n=0;n<11;n++) 
					{
						v[n]=1e10;
					}
					//Les valeurs sont envoyes deux fois, va savoir pourquoi...
					n=sscanf(s,"%d %f %f %f %f %f %f %f %f %f %f %f %f",&i,&v[0],&v[1],&v[2],&v[3],&v[4],&v[5],&v[6],&v[7],&v[8],&v[9],&v[10],&v[11]);
					//CString z;z.Format("%d\n%f\n%f\n%f\n%f\n%f",i,v[0],v[1],v[2],v[3],v[4],v[5]);AfxMessageBox(z);
					//AfxMessageBox(s);
					m_iNb=0;
					/*
					if (v[0]==v[1] && v[2]==v[3] && v[4]==v[5] && v[6]==v[7])
					{ 
						//Les long. sont doubles si la colonne calcul est absente
						for (j=0;j<n-1;j=j+2)
						{
							if (v[j]!=1e10)
							{
								m_fT[m_iNb][col]=v[j];
								//CString z;z.Format("m_fT[%d][%d]: %f",m_iNb,col,v[j]);AfxMessageBox(z);
								if (col==0 && !(m_iVisuGr&1)) m_iVisuGr=m_iVisuGr+1; 
								if (col==1 && !(m_iVisuGr&2)) m_iVisuGr=m_iVisuGr+2; 
								if (col==2 && !(m_iVisuGr&4)) m_iVisuGr=m_iVisuGr+4; 
								if (col==3 && !(m_iVisuGr&8)) m_iVisuGr=m_iVisuGr+8; 
								if (col==4 && !(m_iVisuGr&16)) m_iVisuGr=m_iVisuGr+16; 
								if (col==5 && !(m_iVisuGr&32)) m_iVisuGr=m_iVisuGr+32; 
								m_iNb++;if (m_iNb>10) m_iNb=10;
								
							}
						}	
						col++;if (col>5) col=5;
					}
					else
					*/
					{
						//En provenance d'un fichier .asc, non
						for (j=0;j<n-1;j=j+1)
						{
							if (v[j]!=1e10)
							{
								if (m_iNb<10) 
								{
									m_fT[m_iNb][col]=v[j];
									//CString z;z.Format("m_fT[%d][%d]: %f",m_iNb,col,v[j]);AfxMessageBox(z);
									if (col==0 && !(m_iVisuGr&1)) m_iVisuGr=m_iVisuGr+1; 
									if (col==1 && !(m_iVisuGr&2)) m_iVisuGr=m_iVisuGr+2; 
									if (col==2 && !(m_iVisuGr&4)) m_iVisuGr=m_iVisuGr+4; 
									if (col==3 && !(m_iVisuGr&8)) m_iVisuGr=m_iVisuGr+8; 
									if (col==4 && !(m_iVisuGr&16)) m_iVisuGr=m_iVisuGr+16; 
									if (col==5 && !(m_iVisuGr&32)) m_iVisuGr=m_iVisuGr+32;
									m_OKB[m_iNb]=TRUE; 
								}
								m_iNb++;if (m_iNb>10) m_iNb=10;
							}
						}	
						col++;if (col>5) col=5;
					}
				}
				else
				if (s.Find("End Wavelength")>=0)
				{
					if (NouvSerie==TRUE)
					{
						serie++;if(serie>5) serie=0;
					}
					NouvSerie=TRUE;
				}
				else
				{
					//CString z;z.Format("WS, %s\nSerie: %d",s,serie);AfxMessageBox(z);
					//Initialisation des absisses et ordonnes
					m_iNoAbs[0]=0;//Lambda(nm)
					m_iNoOrd[0]=0;//?
					n=sscanf(s,"%f   %f",&r,&r1);
					if (n==2 && m_iNb<m_iNbMax)
					{
						m_iTypeAcq=0;	//WaveLengthScan
						//Cette srie est visualise
						if (serie==0 && !(m_iVisuGr&1)) m_iVisuGr=m_iVisuGr+1; 
						if (serie==1 && !(m_iVisuGr&2)) m_iVisuGr=m_iVisuGr+2; 
						if (serie==2 && !(m_iVisuGr&4)) m_iVisuGr=m_iVisuGr+4; 
						if (serie==3 && !(m_iVisuGr&8)) m_iVisuGr=m_iVisuGr+8; 
						if (serie==4 && !(m_iVisuGr&16)) m_iVisuGr=m_iVisuGr+16; 
						if (serie==5 && !(m_iVisuGr&32)) m_iVisuGr=m_iVisuGr+32; 
						m_fT[m_iNb][0]=r;
						m_fT[m_iNb][serie+1]=r1;
						//CString z;z.Format("m_fT[%d][%d]:%f",m_iNb,serie,r1);AfxMessageBox(z);
						m_iNb++;
					}
				}
				k=0;
			}
			else
			{
				//Ligne pas complte...
				if (k<149) s.SetAt(k,c);
				k++;
			}
		}
		m_Fic.Close();
		serie++;if(serie>5) serie=0;
		*p_serie=serie;
		//On annule un zoom ventuel
		//Pointeur sur le document en SDI
		if (AfxGetApp()->m_pMainWnd)
		{
			CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
			CBkView *pView=(CBkView*)pFrame-> GetActiveView();
			pView->InitZoom();
		}
		UpdateAllViews(NULL);
	}
}