// Eurosmart.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "eurosmart.h"
#include <conio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
CEurosmart::CEurosmart()
{
	ADR1		=0x330;          
	ADR2		=0x340;          
	IOIN    =ADR2;
	IOOUT   =ADR2;
	MULPLEX =ADR2+1;
	COUNT0  =ADR1;
	COUNT1  =ADR1+1;
	COUNT2  =ADR1+2;
	TIMER   =ADR1+3;
	ADHIGH  =ADR1+4;
	ADLOW   =ADR1+5;
	STARTAD =ADR1+6;
	UPDDA   =ADR1+7;
	DA1LOW  =ADR1+4;
	DA1HIGH =ADR1+5;
	DA2LOW  =ADR1+6;
	DA2HIGH =ADR1+7;
}
//________________________________________
CEurosmart::~CEurosmart()
{
}
//________________________________________
float CEurosmart::LitTension(int NoVoie,char Type,int Nb)
{
	int nb,i,j;
	float u; 

	nb=0;u=(float)0;
  if (GetVersion() & 0x80000000)
	{
		//Windows 98
		switch (Type)
		{
			case 0://Unipolaire      
				setpolar('U');
				setchanel(NoVoie);// [0..7]
				for (j=1;j<=Nb;j++)
				{
					i=readad();
					if (i!=9999)
					{
						nb++;
						u=u+(float)(10.24*i/4095);
					}
				}
			break;
			case 1://Bipolaire
				setpolar('B');
				setchanel(NoVoie);// [0..7]
				for (j=1;j<=Nb;j++)
				{
					i=readad();
					if (i!=9999)
					{
						nb++;
						//Modifi le 14/09/02
						u=u+(float)(/*-5.12+*/10.24*i/4095);
					}
				}
			break;
		}
		if (nb!=0)
			u=u/nb;
		else
			u=(float)(1e10);
	}
	else
	{
		//XP
		u=1e10;
	}
	return u;
}
//________________________________________
void CEurosmart::Sort_U(char NoVoie,float u)
{
	unsigned int i;
  if (GetVersion() & 0x80000000)
	{
		switch (NoVoie)
		{
			case 0:
				setpolar('U');
				i=(int)((u/10.24)*4095);
				setda1(i);
			break;
			case 1:
				setpolar('U');
				i=(int)((u/10.24)*4095);
				setda2(i);
			break;
			case 2:
				setpolar('B');
				i=(int)(2048-(u/10.24)*2048);
				setda2(i);
			break;
		}
	}
}
//Fonctions originales Eurosmart
void CEurosmart::setpolar(char pol)
{
  if ((toupper(pol) == 'U') || (toupper(pol) == 'B'))
	{
  	multies_current_polar = ((toupper(pol) == 'U') ? 1 : 0);
  	_outp(MULPLEX,(multies_current_chanel << 1) | multies_current_polar);
  }
}
//________________________________________
void CEurosmart::setchanel(int ch)
{
  if ((ch >= 0) && (ch <= 7))
  	_outp(MULPLEX,((multies_current_chanel = ch) << 1) | multies_current_polar);
}
//________________________________________
int CEurosmart::readad(void)
{
	int res,n=0;
  
	(void)_inp(STARTAD);             
	for (res=0;res<100;res++)
	{
		//On attend: important sur machines rapides
		;
	} 
	while ((_inp(ADHIGH) & 0x80)&&n<2000)
	{
		n++;
	}  
	if (n<2000)
	{
		for (res=0;res<100;res++) ;//On attend...
		res = ((_inp(ADHIGH) & 0x0F) << 8) + _inp(ADLOW);
		return((multies_current_polar ? res : res-2047));
	}
	else
	{
		return 9999;
	}
}	                            
//________________________________________
void CEurosmart::initdrvad(void)
{
  outputio(0);
  setda1(0);
  setda2(0);
  setpolar('U');
  setchanel(0);
}
//________________________________________
void CEurosmart::outputio(unsigned char value)
{
	_outp(IOOUT,(multies_current_out = value));
} 
//________________________________________
void CEurosmart::setda1(unsigned int value)
{
	multies_update_da((multies_current_da1 = value), multies_current_da2);
}
//________________________________________
void CEurosmart::setda2(unsigned int value)
{
	multies_update_da(multies_current_da1, (multies_current_da2 = value));
}
//________________________________________
void CEurosmart::multies_update_da(unsigned int da1, unsigned int da2)
{
	_outp(DA1LOW, da1 & 0x00FF);
	_outp(DA1HIGH, da1 >> 8);
	_outp(DA2LOW, da2 & 0x00FF);
	_outp(DA2HIGH, da2 >> 8);
	(void) _inp(UPDDA);
}
